## libdivsufsort 2.0.1

=== CMakeLists.txt ===
### cmake file for building libdivsufsort Package ###
cmake_minimum_required(VERSION 2.4)
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules")
include(AppendCompilerFlags)

## SVN revision ##
set(SVN_REVISION "")
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.svn")
  execute_process(COMMAND svn info --xml
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    OUTPUT_VARIABLE SVN_INFO ERROR_QUIET)
  if(SVN_INFO)
    string(REGEX MATCH "<entry[^>]+" SVN_REVISION "${SVN_INFO}")
    string(REGEX REPLACE "^.*revision=\"([0-9]+)\".*$" "\\1" SVN_REVISION "${SVN_REVISION}")
  endif(SVN_INFO)
endif(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.svn")

## Project information ##
project(libdivsufsort C)
set(PROJECT_VENDOR "Yuta Mori")
set(PROJECT_CONTACT "yuta.256@gmail.com")
set(PROJECT_URL "http://libdivsufsort.googlecode.com/")
set(PROJECT_DESCRIPTION "A lightweight suffix sorting library")
file(READ "${CMAKE_CURRENT_SOURCE_DIR}/VERSION" PROJECT_VERSION_FULL)
string(REGEX REPLACE "[\n\r]" "" PROJECT_VERSION_FULL "${PROJECT_VERSION_FULL}")
string(REGEX REPLACE "^([0-9]+)\\.[0-9]+\\.[0-9]+$" "\\1" PROJECT_VERSION_MAJOR "${PROJECT_VERSION_FULL}")
string(REGEX REPLACE "^[0-9]+\\.([0-9]+)\\.[0-9]+$" "\\1" PROJECT_VERSION_MINOR "${PROJECT_VERSION_FULL}")
string(REGEX REPLACE "^[0-9]+\\.[0-9]+\\.([0-9]+)$" "\\1" PROJECT_VERSION_PATCH "${PROJECT_VERSION_FULL}")
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}")
math(EXPR LIBRARY_VERSION_MAJOR "1 + ${PROJECT_VERSION_MAJOR}")
set(LIBRARY_VERSION_MINOR "${PROJECT_VERSION_MINOR}")
set(LIBRARY_VERSION_PATCH "${PROJECT_VERSION_PATCH}")
set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}")
set(LIBRARY_VERSION_FULL "${LIBRARY_VERSION}.${LIBRARY_VERSION_PATCH}")
if(SVN_REVISION)
  set(PROJECT_VERSION_FULL "svn-r${SVN_REVISION}")
endif(SVN_REVISION)

## CPack configuration ##
set(CPACK_GENERATOR "TGZ;TBZ2;ZIP")
set(CPACK_SOURCE_GENERATOR "TGZ;TBZ2;ZIP")
include(ProjectCPack)

## Project options ##
option(BUILD_SHARED_LIBS "Set to OFF to build static libraries" ON)
option(BUILD_EXAMPLES "Build examples" ON)
option(BUILD_DIVSUFSORT64 "Build libdivsufsort64" OFF)
option(USE_OPENMP "Use OpenMP for parallelization" OFF)
option(WITH_LFS "Enable Large File Support" ON)

## Build type ##
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
elseif(CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(CMAKE_VERBOSE_MAKEFILE ON)
endif(NOT CMAKE_BUILD_TYPE)

## Compiler options ##
if(MSVC)
  append_c_compiler_flags("/W4" "VC" CMAKE_C_FLAGS)
  append_c_compiler_flags("/Oi;/Ot;/Ox;/Oy" "VC" CMAKE_C_FLAGS_RELEASE)
  if(USE_OPENMP)
    append_c_compiler_flags("/openmp" "VC" CMAKE_C_FLAGS)
  endif(USE_OPENMP)
elseif(BORLAND)
  append_c_compiler_flags("-w" "BCC" CMAKE_C_FLAGS)
  append_c_compiler_flags("-Oi;-Og;-Os;-Ov;-Ox" "BCC" CMAKE_C_FLAGS_RELEASE)
else(MSVC)
  if(CMAKE_COMPILER_IS_GNUCC)
    append_c_compiler_flags("-Wall" "GCC" CMAKE_C_FLAGS)
    append_c_compiler_flags("-fomit-frame-pointer" "GCC" CMAKE_C_FLAGS_RELEASE)
    if(USE_OPENMP)
      append_c_compiler_flags("-fopenmp" "GCC" CMAKE_C_FLAGS)
    endif(USE_OPENMP)
  else(CMAKE_COMPILER_IS_GNUCC)
    append_c_compiler_flags("-Wall" "UNKNOWN" CMAKE_C_FLAGS)
    append_c_compiler_flags("-fomit-frame-pointer" "UNKNOWN" CMAKE_C_FLAGS_RELEASE)
    if(USE_OPENMP)
      append_c_compiler_flags("-fopenmp;-openmp;-omp" "UNKNOWN" CMAKE_C_FLAGS)
    endif(USE_OPENMP)
  endif(CMAKE_COMPILER_IS_GNUCC)
endif(MSVC)

## Add definitions ##
add_definitions(-DHAVE_CONFIG_H=1 -D__STDC_LIMIT_MACROS -D__STDC_CONSTANT_MACROS -D__STDC_FORMAT_MACROS)

## Add subdirectories ##
add_subdirectory(pkgconfig)
add_subdirectory(include)
add_subdirectory(lib)
if(BUILD_EXAMPLES)
  add_subdirectory(examples)
endif(BUILD_EXAMPLES)

## Add 'uninstall' target ##
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/CMakeModules/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/CMakeModules/cmake_uninstall.cmake")

=== lib/CMakeLists.txt ===
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/../include"
                    "${CMAKE_CURRENT_BINARY_DIR}/../include")

set(divsufsort_SRCS divsufsort.c sssort.c trsort.c utils.c)

## libdivsufsort ##
add_library(divsufsort ${divsufsort_SRCS})
install(TARGETS divsufsort
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib)
set_target_properties(divsufsort PROPERTIES
  VERSION   "${LIBRARY_VERSION_FULL}"
  SOVERSION "${LIBRARY_VERSION_MAJOR}"
  DEFINE_SYMBOL DIVSUFSORT_BUILD_DLL
  RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/../examples")

## libdivsufsort64 ##
if(BUILD_DIVSUFSORT64)
  add_library(divsufsort64 ${divsufsort_SRCS})
  install(TARGETS divsufsort64
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib)
  set_target_properties(divsufsort64 PROPERTIES
    VERSION   "${LIBRARY_VERSION_FULL}"
    SOVERSION "${LIBRARY_VERSION_MAJOR}"
    DEFINE_SYMBOL DIVSUFSORT_BUILD_DLL
    COMPILE_FLAGS "-DBUILD_DIVSUFSORT64"
    RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/../examples")
endif(BUILD_DIVSUFSORT64)

=== pkgconfig/CMakeLists.txt ===
## generate libdivsufsort.pc ##
set(prefix "${CMAKE_INSTALL_PREFIX}")
set(W64BIT "")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/libdivsufsort.pc.cmake" "${CMAKE_CURRENT_BINARY_DIR}/libdivsufsort.pc" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libdivsufsort.pc" DESTINATION lib/pkgconfig)
if(BUILD_DIVSUFSORT64)
  set(W64BIT "64")
  configure_file("${CMAKE_CURRENT_SOURCE_DIR}/libdivsufsort.pc.cmake" "${CMAKE_CURRENT_BINARY_DIR}/libdivsufsort64.pc" @ONLY)
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libdivsufsort64.pc" DESTINATION lib/pkgconfig)
endif(BUILD_DIVSUFSORT64)

=== debian/changelog ===
libdivsufsort (2.0.1-5) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Tue, 24 Nov 2020 09:32:42 +0100

libdivsufsort (2.0.1-4) unstable; urgency=medium

  * Team upload.
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1

 -- Andreas Tille <tille@debian.org>  Thu, 20 Sep 2018 21:39:26 +0200

libdivsufsort (2.0.1-3) unstable; urgency=medium

  * Team upload.

  [ Tomasz Buchert ]
  * debhelper 10
  * d/watch: version=4

  [ Andreas Tille ]
  * cme fix dpkg-control
  * Standards-Version: 4.0.0 (no changes needed)
  * Use secure Vcs-Browser
  * Hardening

  [ Fabian Klötzl ]
  * deactivate broken autoconf
  * update copyright source url

 -- Andreas Tille <tille@debian.org>  Thu, 13 Jul 2017 10:02:52 +0200

libdivsufsort (2.0.1-2) unstable; urgency=medium

  * Changed section from science to libs
  * Changed watch urls to GitHub, hoping that upstream becomes active again.
  * The -dev package now depends on the library (Closes: #794729)
  * Minor changes include: added symbols file, cleaner rules/install/docs/dirs,
    removed git-orig-source script, fixed make clean target, updated description
  * Introduced multi-arch support:
    Added Multi-Arch: same and Pre-Depends: ${misc:Pre-Depends}
    Patched upstream cmake files, so all files are installed into their proper,
    architecture-dependent directories. (Thanks to Tomasz for the patch.)

 -- Fabian Klötzl <kloetzl@evolbio.mpg.de>  Sun, 23 Aug 2015 16:59:44 +0200

libdivsufsort (2.0.1-1) unstable; urgency=low

  * Initial release (Closes: #752825)

 -- Fabian Klötzl <kloetzl@evolbio.mpg.de>  Wed, 22 Jul 2015 12:07:09 +0200

=== debian/control ===
Source: libdivsufsort
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Fabian Klötzl <kloetzl@evolbio.mpg.de>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13)
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/libdivsufsort
Vcs-Git: https://salsa.debian.org/med-team/libdivsufsort.git
Homepage: https://github.com/y-256/libdivsufsort
Rules-Requires-Root: no

Package: libdivsufsort3
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: fast suffix array construction
 The libdivsufsort project provides a fast, lightweight, and robust
 C API library to construct the suffix array and the Burrows-Wheeler
 transformed string for any input string of a constant-size alphabet.
 .
 This package installs shared library files.

Package: libdivsufsort-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libdivsufsort3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: libdivsufsort header files
 The libdivsufsort project provides a fast, lightweight, and robust
 C API library to construct the suffix array and the Burrows-Wheeler
 transformed string for any input string of a constant-size alphabet.
 .
 This package installs files needed for development.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --buildsystem=cmake --without autoreconf

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE="Release" \
		-DBUILD_DIVSUFSORT64=YES \
		-DCMAKE_LIBRARY_ARCHITECTURE=${DEB_HOST_MULTIARCH}

not_override_dh_install_since_there_is_no_static_lib:
	dh_install
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev debian/tmp/usr/include/* usr/include \
		    --movedev "debian/tmp/usr/lib/*/pkgconfig/*.pc" usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		    debian/tmp/usr/lib/*/*.so
	find debian -name "lib*.la" -delete

=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/libdivsufsort-$1\.tar\.gz/ \
  https://github.com/y-256/libdivsufsort/tags .*/v?(\d\S*)\.tar\.gz

# If upstream becomes active again, we might want to watch releases.
# https://github.com/#GITHUBUSER#/#PACKAGE#/releases .*/archive/#PREFIX#(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
#
